#pragma once
#include <windows.h>
#include <stdio.h>
#include <math.h>
#include <vfw.h>

#define AUDIO_BUF_SIZE (2*1024*1024)

class CAVSReader
{
public:
	CAVSReader();
	~CAVSReader();

	bool OpenAVSFile(const char *szAVSFile);
	void CloseAVSFile();

	BYTE *GetBytePtr() { return m_pVideoFrame; }
	BYTE *GetAudioBytePtr() { return m_pAudioFrame; }
	BYTE *GetFrame(LONG *yuy2c_size = NULL, LONG *samples = NULL);
	BYTE *GetFrame(int nFrame, LONG *yuy2c_size, LONG *samples);

	// Video
	bool HasVideo();
	int GetNumFrames(int nCaps = 0);
	int GetWidth();
	int GetHeight();
	DWORD GetScale();
	DWORD GetRate();

	// Audio
	bool HasAudio();
	int  GetChannels();
	int  GetSampleRate();
	int  GetBitsPerSec();
	PCMWAVEFORMAT* GetWF();
	void GetAudioSamplesToRead(int nSampleSize);
	LONG GetAudioFrame();

	BITMAPINFOHEADER m_BMI;
private:
	int nFrameCount;
	int nAudioFrameCount;
	int FramesRead;
	DWORD dwScale, dwRate;

	PAVIFILE pAVIFileIn;
	PAVISTREAM pVideoStream;
	PAVISTREAM pAudioStream;
	AVISTREAMINFO videoStreamInfo;
	AVISTREAMINFO audioStreamInfo;
	BITMAPINFOHEADER biyuv;
	PCMWAVEFORMAT wavFmt;
	int m_nAudioSamplesToRead;
	BYTE *m_pAudioFrame;
	BYTE *m_pVideoFrame;
	bool m_bHasAudio;
	bool m_bHasVideo;

	int m_nTotalVideoFrames;
	int m_nTotalAudioFrames;
};




